#!/usr/bin/env python
# -*- coding: utf-8 -*-
# license: wtfpl
# http://www.wtfpl.net/txt/copying/

import Tkinter as tk
import meter as m
import serial,time

rangelower = 0              # untere Bereichsgrenze der Instrumente
rangeupper = 3300           # obere Bereichsgrenze der instrumente
mult = rangeupper/1023.0    # Multiplikator für Anzeige 0 ... 3300mV
file_is_open = 0
time_old = 0


# Da das micro:bit schon jede Menge Messwerte gesendet hat, die von der
# seriellen Schnittstelle gepuffert wurden, erst mal den Puffer leeren:
try:
    ser = serial.Serial("/dev/ttyACM0",115200, timeout=1)
    ser.flushInput()
except:
    pass


def read_adc():

    try:
        ser = serial.Serial("/dev/ttyACM0",115200, timeout=1)
    except:
        print "-----> serielle Schnittstelle nicht vorhanden"
        quit()

    ser_string=ser.readline()                      # jeweils eine Zeile einlesen
    ser_liste = ser_string.split(chr(9))           # Strings der ADC-Werte rausangeln
    try:
        # jeweils Fliesskommazahl ADC-Wert * Multiplikator bilden
        # Dann für Anzeige und Log in ganze Zahlen wandeln (ergibt mV):
        meter0.set(int(float(ser_liste[0])*mult))
        meter1.set(int(float(ser_liste[1])*mult))
        meter2.set(int(float(ser_liste[2])*mult))
    except:
        print "Fehler!"
        ser.flushInput()

##          ins File schreiben:

    global time_old
    global file_is_open

    if (file_is_open == 1):
        interval = get_interval()
        time_new = time.time()
        if ((time_new - time_old) >= interval):
            time_old = time_new
            try:
                ltime = time.localtime()
                h, m , s = ltime[3:6]
                time_string = "{0:02d}:{1:02d}:{2:02d}".format(h,m,s)
                logfile.write (time_string + chr(9) + ser_string)
            except:
                 print "writing failed"

#   mit main.after läuft read_adc() als Schleife
    main.after(5,read_adc)  # sollte > 4 sein



def get_interval():

    get_interval = entry5.get() 
    try:
        interval= float(get_interval)
    except:
        interval = 1
    return interval



def start_log():

    global logfile
    global file_is_open

    filename = "uBitCockpit.csv"
    getfilename= entry6.get()
    if getfilename != "":
        filename = getfilename
    logfile = open (filename,"a+")   # +a: append
    file_is_open = 1
    print "filename=", filename

 
def stop_log():
    global file_is_open
    try:
        logfile.close()
        file_is_open = 0
    except:
        pass

def ende():
    print("Ende !")
    try:
        thread.stop(get_values, ())
        file_is_open = 0
        ser.write("e"+ "0")
        ser.close()
        logfile.close()
    except:
        pass
    main.destroy()


main=tk.Tk()

main.title("uBit-Cockpit")
main0 = tk.Frame(main)      # main0 für Ueberschrift
main0.pack()
main1 = tk.Frame(main)      # main1 für Messwerke
main1.pack()
main2 = tk.Frame(main)      # main2 für Intervall/Dateiname
main2.pack()
main3 = tk.Frame(main)      # main3 für Buttons
main3.pack()

text0 = tk.Label(main0, text="uBit-Cockpit - 3 ADC-Eingänge 0...3,3V", font="bold")
text0.pack(side="top",padx=20,pady=10)

# übler Notbehelf für die Instrumentenbeschriftung
text1 = tk.Label(main1, text=\
"ADC0                                          \
 ADC1                                          \
 ADC2")
text1.pack(side="bottom")

meter0=m.Meter(main1,height=200,width=200,)
meter0.setrange(rangelower,rangeupper)
meter0.pack(side="left")
meter0.blob("black")

meter1=m.Meter(main1,height=200,width=200)
meter1.setrange(rangelower,rangeupper)
meter1.pack(side="left")
meter1.blob("black")

meter2=m.Meter(main1,height=200,width=200)
meter2.setrange(rangelower,rangeupper)
meter2.pack(side="left")
meter2.blob("black")



# Eingabe Intervall
frame5 = (tk.Frame(main2))
frame5.pack(side="left",anchor="w")
entry5 = tk.Entry(frame5, width=5,text="0.1")
entry5.pack(side="left", anchor="w",padx = 10)
text5 = tk.Label(frame5, text="Intervall der Logfile-Einträge (in s)   ")
text5.pack(side="left",pady=10)



# Eingabe Logfile-Name 
frame6 = (tk.Frame(main2))
frame6.pack(sid="left")
entry6 = tk.Entry(frame6, width=16)
entry6.pack(side="left", padx = 10)
text6 = tk.Label(frame6, text = "Name des Logfiles ")
text6.pack(side="left", pady=10)


# Start/Stop Log
frame7 = (tk.Frame(main3))
frame7.pack(side="left")
widget_start = tk.Button(frame7, text="Start Log",command=start_log)
widget_start.pack(side="left", padx = 10)
widget_stop = tk.Button(frame7, text="Stop Log",command=stop_log)
widget_stop.pack(side="left", pady=10)

# Quit-Button

button7 = tk.Button(main3, text="Quit",command=ende)
button7.pack(side="right", padx = 10)


main.after(1,read_adc())
main.mainloop()
